diff --git a/web/pgadmin/browser/__init__.py b/web/pgadmin/browser/__init__.py
index 517232210..4a7e18eb0 100644
--- a/web/pgadmin/browser/__init__.py
+++ b/web/pgadmin/browser/__init__.py
@@ -54,7 +54,8 @@ from pgadmin.utils.master_password import validate_master_password, \
     set_crypt_key, process_masterpass_disabled
 from pgadmin.model import User
 from pgadmin.utils.constants import MIMETYPE_APP_JS, PGADMIN_NODE,\
-    INTERNAL, KERBEROS, LDAP, QT_DEFAULT_PLACEHOLDER, OAUTH2, WEBSERVER
+    INTERNAL, KERBEROS, LDAP, QT_DEFAULT_PLACEHOLDER, OAUTH2, WEBSERVER,\
+    VW_EDT_DEFAULT_PLACEHOLDER
 from pgadmin.authenticate import AuthSourceManager
 
 try:
@@ -854,6 +855,7 @@ def utils():
             logout_url=get_logout_url(),
             platform=sys.platform,
             qt_default_placeholder=QT_DEFAULT_PLACEHOLDER,
+            vw_edt_default_placeholder=VW_EDT_DEFAULT_PLACEHOLDER,
             enable_psql=config.ENABLE_PSQL
         ),
         200, {'Content-Type': MIMETYPE_APP_JS})
diff --git a/web/pgadmin/browser/register_browser_preferences.py b/web/pgadmin/browser/register_browser_preferences.py
index 0b0224b3d..5d3482be4 100644
--- a/web/pgadmin/browser/register_browser_preferences.py
+++ b/web/pgadmin/browser/register_browser_preferences.py
@@ -10,7 +10,7 @@ import sys
 from flask_babel import gettext
 from pgadmin.utils.constants import PREF_LABEL_DISPLAY,\
     PREF_LABEL_KEYBOARD_SHORTCUTS, PREF_LABEL_TABS_SETTINGS, \
-    PREF_LABEL_OPTIONS, QT_DEFAULT_PLACEHOLDER
+    PREF_LABEL_OPTIONS, QT_DEFAULT_PLACEHOLDER, VW_EDT_DEFAULT_PLACEHOLDER
 from flask_security import current_user
 import config
 
@@ -483,7 +483,7 @@ def register_browser_preferences(self):
     self.ve_edt_tab_title = self.preference.register(
         'tab_settings', 'vw_edt_tab_title_placeholder',
         gettext("View/Edit data tab title"),
-        'text', '%SCHEMA%.%TABLE%/%DATABASE%/%USERNAME%@%SERVER%',
+        'text', VW_EDT_DEFAULT_PLACEHOLDER,
         category_label=PREF_LABEL_DISPLAY,
         help_str=gettext(
             'Supported placeholders are %SCHEMA%, %TABLE%, %DATABASE%, '
diff --git a/web/pgadmin/browser/server_groups/servers/__init__.py b/web/pgadmin/browser/server_groups/servers/__init__.py
index 509f6cf92..a1cc7e495 100644
--- a/web/pgadmin/browser/server_groups/servers/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/__init__.py
@@ -1284,7 +1284,7 @@ class ServerNode(PGChildNodeView):
             }
         )
 
-    def connect(self, gid, sid, user_name=None):
+    def connect(self, gid, sid, user_name=None, resp_json=False):
         """
         Connect the Server and return the connection object.
         Verification Process before Connection:
@@ -1331,12 +1331,15 @@ class ServerNode(PGChildNodeView):
         else:
             return unauthorized(gettext(UNAUTH_REQ))
 
-        data = {}
+        data = None
         if request.form:
             data = request.form
         elif request.data:
             data = json.loads(request.data, encoding='utf-8')
 
+        if data is None:
+            data = {}
+
         password = None
         passfile = None
         tunnel_password = None
@@ -1408,7 +1411,7 @@ class ServerNode(PGChildNodeView):
         if prompt_password or prompt_tunnel_password:
             return self.get_response_for_password(server, 428, prompt_password,
                                                   prompt_tunnel_password,
-                                                  user=user_name)
+                                                  user=user_name, resp_json=resp_json)
 
         status = True
         try:
@@ -1423,7 +1426,8 @@ class ServerNode(PGChildNodeView):
         except Exception as e:
             current_app.logger.exception(e)
             return self.get_response_for_password(
-                server, 401, True, True, getattr(e, 'message', str(e)))
+                server, 401, True, True, getattr(e, 'message', str(e)),
+                resp_json=resp_json)
 
         if not status:
 
@@ -1435,7 +1439,7 @@ class ServerNode(PGChildNodeView):
                 return internal_server_error(errmsg)
 
             return self.get_response_for_password(server, 401, True,
-                                                  True, errmsg)
+                                                  True, errmsg, resp_json=resp_json)
         else:
             if save_password and config.ALLOW_SAVE_PASSWORD:
                 try:
@@ -1859,47 +1863,54 @@ class ServerNode(PGChildNodeView):
 
     def get_response_for_password(self, server, status, prompt_password=False,
                                   prompt_tunnel_password=False, errmsg=None,
-                                  user=None):
+                                  user=None, resp_json=False):
 
         if server.use_ssh_tunnel:
+            data = {
+                "server_label": server.name,
+                "username": server.username,
+                "tunnel_username": server.tunnel_username,
+                "tunnel_host": server.tunnel_host,
+                "tunnel_identity_file": server.tunnel_identity_file,
+                "errmsg": errmsg,
+                "service": server.service,
+                "prompt_tunnel_password": prompt_tunnel_password,
+                "prompt_password": prompt_password,
+                "allow_save_password": True if
+                    config.ALLOW_SAVE_PASSWORD and
+                    session['allow_save_password'] else False,
+                "allow_save_tunnel_password": True if
+                    config.ALLOW_SAVE_TUNNEL_PASSWORD and
+                    session['allow_save_password'] else False
+            }
             return make_json_response(
                 success=0,
                 status=status,
                 result=render_template(
                     'servers/tunnel_password.html',
-                    server_label=server.name,
-                    username=server.username,
-                    tunnel_username=server.tunnel_username,
-                    tunnel_host=server.tunnel_host,
-                    tunnel_identity_file=server.tunnel_identity_file,
-                    errmsg=errmsg,
                     _=gettext,
-                    service=server.service,
-                    prompt_tunnel_password=prompt_tunnel_password,
-                    prompt_password=prompt_password,
-                    allow_save_password=True if
-                    config.ALLOW_SAVE_PASSWORD and
-                    session['allow_save_password'] else False,
-                    allow_save_tunnel_password=True if
-                    config.ALLOW_SAVE_TUNNEL_PASSWORD and
-                    session['allow_save_password'] else False
-                )
+                    **data,
+                ) if not resp_json else data
             )
         else:
+            data = {
+                "server_label": server.name,
+                "username": server.username,
+                "errmsg": errmsg,
+                "service": server.service,
+                "prompt_password": True,
+                "allow_save_password": True if
+                    config.ALLOW_SAVE_PASSWORD and
+                    session['allow_save_password'] else False,
+            }
             return make_json_response(
                 success=0,
                 status=status,
                 result=render_template(
                     'servers/password.html',
-                    server_label=server.name,
-                    username=user if user else server.username,
-                    errmsg=errmsg,
-                    service=server.service,
                     _=gettext,
-                    allow_save_password=True if
-                    config.ALLOW_SAVE_PASSWORD and
-                    session['allow_save_password'] else False,
-                )
+                    **data
+                ) if not resp_json else data
             )
 
     def clear_saved_password(self, gid, sid):
diff --git a/web/pgadmin/browser/static/js/ConnectServerContent.jsx b/web/pgadmin/browser/static/js/ConnectServerContent.jsx
new file mode 100644
index 000000000..8bd952f4c
--- /dev/null
+++ b/web/pgadmin/browser/static/js/ConnectServerContent.jsx
@@ -0,0 +1,103 @@
+import React, { useState } from 'react';
+import gettext from 'sources/gettext';
+import { Box } from '@material-ui/core';
+import { DefaultButton, PrimaryButton } from '../../../static/js/components/Buttons';
+import CloseIcon from '@material-ui/icons/CloseRounded';
+import CheckRoundedIcon from '@material-ui/icons/CheckRounded';
+import PropTypes from 'prop-types';
+import { useModalStyles } from '../../../static/js/helpers/ModalProvider';
+import { FormFooterMessage, InputCheckbox, InputText, MESSAGE_TYPE } from '../../../static/js/components/FormComponents';
+
+export default function ConnectServerContent({closeModal, data, onOK}) {
+  const classes = useModalStyles();
+  const [formData, setFormData] = useState({
+    tunnel_password: '',
+    save_tunnel_password: false,
+    password: '',
+    save_password: false,
+  });
+
+  const onTextChange = (e, id) => {
+    let val = e;
+    if(e && e.target) {
+      val = e.target.value;
+    }
+    setFormData((prev)=>({...prev, [id]: val}));
+  };
+
+  if(!data) {
+    return <>No data</>;
+  }
+
+  return (
+    <Box display="flex" flexDirection="column" height="100%">
+      <Box flexGrow="1" p={2}>
+        {data.prompt_tunnel_password && <>
+          <Box>
+            <span style={{fontWeight: 'bold'}}>
+              {data.tunnel_identity_file ?
+                gettext('Please enter the SSH Tunnel password for the identity file \'%s\' to connect the server "%s"', data.tunnel_identity_file, data.tunnel_host)
+                : gettext('Please enter the SSH Tunnel password for the user \'%s\' to connect the server "%s"', data.tunnel_username, data.tunnel_host)
+              }
+            </span>
+          </Box>
+          <Box marginTop='12px'>
+            <InputText type="password" value={formData['tunnel_password']} maxLength={null}
+              onChange={(e)=>onTextChange(e, 'tunnel_password')} autoFocus />
+          </Box>
+          <Box marginTop='12px'>
+            <InputCheckbox controlProps={{label: gettext('Save Password')}} value={formData['save_tunnel_password']}
+              onChange={(e)=>onTextChange(e.target.checked, 'save_tunnel_password')} disabled={!data.allow_save_tunnel_password} />
+          </Box>
+        </>}
+        {data.prompt_password && <>
+          <Box>
+            <span style={{fontWeight: 'bold'}}>
+              {data.username ?
+                gettext('Please enter the password for the user \'%s\' to connect the server - "%s"', data.username, data.server_label)
+                : gettext('Please enter the password for the user to connect the server - "%s"', data.server_label)
+              }
+            </span>
+          </Box>
+          <Box marginTop='12px'>
+            <InputText type="password" value={formData['password']} maxLength={null}
+              onChange={(e)=>onTextChange(e, 'password')} autoFocus />
+          </Box>
+          <Box marginTop='12px'>
+            <InputCheckbox controlProps={{label: gettext('Save Password')}} value={formData['save_password']}
+              onChange={(e)=>onTextChange(e.target.checked, 'save_password')} disabled={!data.allow_save_password} />
+          </Box>
+        </>}
+        <FormFooterMessage type={MESSAGE_TYPE.ERROR} message={data.errmsg} closable={false} style={{
+          position: 'unset', padding: '12px 0px 0px'
+        }}/>
+      </Box>
+      <Box className={classes.footer}>
+        <DefaultButton data-test="close" startIcon={<CloseIcon />} onClick={()=>{
+          closeModal();
+        }} >{gettext('Cancel')}</DefaultButton>
+        <PrimaryButton data-test="save" className={classes.margin} startIcon={<CheckRoundedIcon />} onClick={()=>{
+          let postFormData = new FormData();
+          if(data.prompt_tunnel_password) {
+            postFormData.append('tunnel_password', formData.tunnel_password);
+            formData.save_tunnel_password &&
+              postFormData.append('save_tunnel_password', formData.save_tunnel_password);
+          }
+          if(data.prompt_password) {
+            postFormData.append('password', formData.password);
+            formData.save_password &&
+              postFormData.append('save_password', formData.save_password);
+          }
+          onOK?.(postFormData);
+          closeModal();
+        }} >{gettext('OK')}</PrimaryButton>
+      </Box>
+    </Box>
+  );
+}
+
+ConnectServerContent.propTypes = {
+  closeModal: PropTypes.func,
+  data: PropTypes.object,
+  onOK: PropTypes.func
+};
diff --git a/web/pgadmin/browser/static/js/collection.js b/web/pgadmin/browser/static/js/collection.js
index 78760632d..9b894c9b6 100644
--- a/web/pgadmin/browser/static/js/collection.js
+++ b/web/pgadmin/browser/static/js/collection.js
@@ -119,8 +119,8 @@ define([
         );
       },
       show_query_tool: function() {
-        if(pgAdmin.DataGrid) {
-          pgAdmin.DataGrid.show_query_tool('', pgAdmin.Browser.tree.selected());
+        if(pgAdmin.Tools.SQLEditor) {
+          pgAdmin.Tools.SQLEditor.showQueryTool('', pgAdmin.Browser.tree.selected());
         }
       },
       show_search_objects: function() {
diff --git a/web/pgadmin/browser/static/js/keyboard.js b/web/pgadmin/browser/static/js/keyboard.js
index 989f8bb5b..1aa88c231 100644
--- a/web/pgadmin/browser/static/js/keyboard.js
+++ b/web/pgadmin/browser/static/js/keyboard.js
@@ -253,7 +253,7 @@ _.extend(pgBrowser.keyboardNavigation, {
       return;
 
     // Call data grid method to render query tool
-    pgAdmin.DataGrid.show_query_tool('', tree.i);
+    pgAdmin.Tools.SQLEditor.showQueryTool('', tree.i);
   },
   bindSubMenuViewData: function() {
     const tree = this.getTreeDetails();
@@ -262,7 +262,7 @@ _.extend(pgBrowser.keyboardNavigation, {
       return;
 
     // Call data grid method to render view data
-    pgAdmin.DataGrid.show_data_grid({'mnuid': 1}, tree.i);
+    pgAdmin.Tools.SQLEditor.showViewData({'mnuid': 1}, tree.i);
   },
   bindSubMenuSearchObjects: function() {
     const tree = this.getTreeDetails();
diff --git a/web/pgadmin/browser/static/js/node.js b/web/pgadmin/browser/static/js/node.js
index 9e5244b7b..4b28eeb98 100644
--- a/web/pgadmin/browser/static/js/node.js
+++ b/web/pgadmin/browser/static/js/node.js
@@ -975,7 +975,7 @@ define('pgadmin.browser.node', [
           sql_url = 'sql';
         }
         // Open data grid & pass the URL for fetching
-        pgAdmin.DataGrid.show_query_tool(
+        pgAdmin.Tools.SQLEditor.showQueryTool(
           obj.generate_url(i, sql_url, d, true),
           i, scriptType
         );
@@ -1001,7 +1001,7 @@ define('pgadmin.browser.node', [
           };
           pgBrowser.Node.callbacks.show_script(data);
         }else{
-          pgAdmin.DataGrid.show_query_tool('', i);
+          pgAdmin.Tools.SQLEditor.showQueryTool('', i);
         }
       },
 
diff --git a/web/pgadmin/browser/static/js/preferences.js b/web/pgadmin/browser/static/js/preferences.js
index 600027ac4..3f1aab16b 100644
--- a/web/pgadmin/browser/static/js/preferences.js
+++ b/web/pgadmin/browser/static/js/preferences.js
@@ -112,6 +112,10 @@ _.extend(pgBrowser, {
     }, 500);
   },
 
+  triggerPreferencesChange: function(moduleChanged) {
+    $.event.trigger('prefchange:'+moduleChanged);
+  },
+
   reflectPreferences: function(module) {
     let obj = this;
 
@@ -130,7 +134,13 @@ _.extend(pgBrowser, {
   },
 
   onPreferencesChange: function(module, eventHandler) {
-    $(pgWindow).on('prefchange:'+module, function(event) {
+    let eventWindow = pgWindow;
+    if (window.location === window.parent?.location ) {
+      // The page is in a new tab
+      eventWindow = window;
+    }
+
+    $(eventWindow).on('prefchange:'+module, function(event) {
       eventHandler(event);
     });
   },
diff --git a/web/pgadmin/browser/static/js/toolbar.js b/web/pgadmin/browser/static/js/toolbar.js
index b97165f2d..fc915026e 100644
--- a/web/pgadmin/browser/static/js/toolbar.js
+++ b/web/pgadmin/browser/static/js/toolbar.js
@@ -112,11 +112,11 @@ export function initializeToolbar(panel, wcDocker) {
   // Listen on button click event.
   panel.on(wcDocker.EVENT.BUTTON, function(data) {
     if ('name' in data && data.name === gettext('Query Tool'))
-      pgAdmin.DataGrid.show_query_tool('', pgAdmin.Browser.tree.selected());
+      pgAdmin.Tools.SQLEditor.showQueryTool('', pgAdmin.Browser.tree.selected());
     else if ('name' in data && data.name === gettext('View Data'))
-      pgAdmin.DataGrid.show_data_grid({mnuid: 3}, pgAdmin.Browser.tree.selected());
+      pgAdmin.Tools.SQLEditor.showViewData({mnuid: 3}, pgAdmin.Browser.tree.selected());
     else if ('name' in data && data.name === gettext('Filtered Rows'))
-      pgAdmin.DataGrid.show_filtered_row({mnuid: 4}, pgAdmin.Browser.tree.selected());
+      pgAdmin.Tools.SQLEditor.show_filtered_row({mnuid: 4}, pgAdmin.Browser.tree.selected());
     else if ('name' in data && data.name === gettext('Search objects'))
       pgAdmin.SearchObjects.show_search_objects('', pgAdmin.Browser.tree.selected());
     else if ('name' in data && data.name === gettext('PSQL Tool')){
diff --git a/web/pgadmin/misc/static/explain/js/svg_downloader.js b/web/pgadmin/misc/static/explain/js/svg_downloader.js
index 10a3b0d4d..bf1728a84 100644
--- a/web/pgadmin/misc/static/explain/js/svg_downloader.js
+++ b/web/pgadmin/misc/static/explain/js/svg_downloader.js
@@ -14,7 +14,7 @@ let svgDownloader = {
   },
 
   downloadSVG: function(content, fileName)  {
-    // Safari xlink NS issue fix
+    // Safari xlink NS issue fixblobURL
     content = content.replace(/NS\d+:href/gi, 'xlink:href');
 
     var svgURL = this.blobURL(content, 'image/svg+xml');
diff --git a/web/pgadmin/preferences/static/js/components/PreferencesComponent.jsx b/web/pgadmin/preferences/static/js/components/PreferencesComponent.jsx
index e3c912a1a..4e1383aed 100644
--- a/web/pgadmin/preferences/static/js/components/PreferencesComponent.jsx
+++ b/web/pgadmin/preferences/static/js/components/PreferencesComponent.jsx
@@ -26,7 +26,7 @@ import pgAdmin from 'sources/pgadmin';
 import { DefaultButton, PgIconButton, PrimaryButton } from '../../../../static/js/components/Buttons';
 import BaseUISchema from 'sources/SchemaView/base_schema.ui';
 import { getBinaryPathSchema } from '../../../../browser/server_groups/servers/static/js/binary_path.ui';
-import { _set_dynamic_tab } from '../../../../tools/datagrid/static/js/show_query_tool';
+import { _set_dynamic_tab } from '../../../../tools/sqleditor/static/js/show_query_tool';
 
 class PreferencesSchema extends BaseUISchema {
   constructor(initValues = {}, schemaFields = []) {
@@ -289,7 +289,7 @@ export default function PreferencesComponent({ ...props }) {
         if(_el.name == 'column_data_auto_resize') {
           size_control_id = _el.id;
         }
-        
+
       });
       element.disabled = (state) => {
         return state[size_control_id] != 'by_data';
@@ -343,7 +343,7 @@ export default function PreferencesComponent({ ...props }) {
     }
 
     if (note && note.length > 0) {
-      //Add Note for Nodes 
+      //Add Note for Nodes
       preferencesData.push(
         {
           id: _.uniqueId('note') + subNode.id,
diff --git a/web/pgadmin/settings/__init__.py b/web/pgadmin/settings/__init__.py
index 371b951f8..f83412806 100644
--- a/web/pgadmin/settings/__init__.py
+++ b/web/pgadmin/settings/__init__.py
@@ -122,7 +122,7 @@ def store(setting=None, value=None):
             store_setting(setting, value)
     except Exception as e:
         success = 0
-        errormsg = e.message
+        errormsg = str(e)
 
     try:
         info = traceback.format_exc()
@@ -141,12 +141,21 @@ def reset_layout():
     """Reset configuration setting"""
 
     try:
-        db.session.query(Setting) \
-            .filter(Setting.user_id == current_user.id)\
-            .filter((Setting.setting == 'Browser/Layout') |
-                    (Setting.setting == 'SQLEditor/Layout') |
-                    (Setting.setting == 'Debugger/Layout'))\
-            .delete()
+        if request.params['setting'] in [
+                'Browser/Layout', 'SQLEditor/Layout', 'Debugger/Layout']:
+            db.session.query(Setting) \
+                .filter(Setting.user_id == current_user.id) \
+                .filter((Setting.setting == 'Browser/Layout') |
+                        (Setting.setting == 'SQLEditor/Layout') |
+                        (Setting.setting == 'Debugger/Layout')) \
+                .delete()
+        else:
+            db.session.query(Setting) \
+                .filter(Setting.user_id == current_user.id)\
+                .filter((Setting.setting == 'Browser/Layout') |
+                        (Setting.setting == 'SQLEditor/Layout') |
+                        (Setting.setting == 'Debugger/Layout'))\
+                .delete()
 
         db.session.commit()
     except Exception as e:
diff --git a/web/pgadmin/static/bundle/app.js b/web/pgadmin/static/bundle/app.js
index fc35da653..cbf89aee4 100644
--- a/web/pgadmin/static/bundle/app.js
+++ b/web/pgadmin/static/bundle/app.js
@@ -8,7 +8,7 @@
 //////////////////////////////////////////////////////////////
 
 define('app', [
-  'sources/pgadmin', 'bundled_browser', 'pgadmin.datagrid',
+  'sources/pgadmin', 'bundled_browser',
 ], function(pgAdmin) {
   var initializeModules = function(Object) {
     for (var key in Object) {
diff --git a/web/pgadmin/static/js/Explain/Analysis.jsx b/web/pgadmin/static/js/Explain/Analysis.jsx
new file mode 100644
index 000000000..fa822b156
--- /dev/null
+++ b/web/pgadmin/static/js/Explain/Analysis.jsx
@@ -0,0 +1,215 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import { makeStyles } from '@material-ui/styles';
+import React from 'react';
+import clsx from 'clsx';
+import _ from 'lodash';
+import ArrowRightAltIcon from '@material-ui/icons/ArrowRightAlt';
+import FiberManualRecordIcon from '@material-ui/icons/FiberManualRecord';
+import HTMLReactParse from 'html-react-parser';
+import { commonTableStyles } from '../Theme';
+import PropTypes from 'prop-types';
+
+const useStyles = makeStyles((theme)=>({
+  collapsible: {
+    cursor: 'pointer',
+  },
+  collapseParent: {
+    borderBottom: '2px dashed '+theme.palette.primary.main,
+  },
+  level2: {
+    backgroundColor: '#fff',
+    color: '#000',
+  },
+  level3: {
+    backgroundColor: '#fff',
+    color: '#000',
+  },
+  level4: {
+    backgroundColor: '#fff',
+    color: '#000',
+  },
+}));
+
+function getRowClassname(data, collapseParent) {
+  const classes = useStyles();
+  let className = [];
+  if(data['Plans']?.length > 0) {
+    className.push(classes.collapsible);
+  }
+  if(!_.isEmpty(data['exclusive_flag'])) {
+    className.push(classes['level'+data['exclusive_flag']]);
+  }
+  if(!_.isEmpty(data['inclusive_flag'])) {
+    className.push(classes['level'+data['inclusive_flag']]);
+  }
+  if(!_.isEmpty(data['rowsx_flag'])) {
+    className.push(classes['level'+data['rowsx_flag']]);
+  }
+  if(collapseParent) {
+    className.push(classes.collapseParent);
+  }
+  return className;
+}
+
+function NodeText({displayText, extraInfo}) {
+  return (
+    <>
+      <ArrowRightAltIcon fontSize="small" /> {displayText}
+      {extraInfo?.length > 0 && <ul>
+        {extraInfo.map((item, i)=>{
+          return <li key={i}>{HTMLReactParse(item)}</li>;
+        })}
+      </ul>}
+    </>);
+}
+NodeText.propTypes = {
+  displayText: PropTypes.string,
+  extraInfo: PropTypes.array,
+};
+
+function ExplainRow({row, show, activeExId, setActiveExId, collapsedExId, toggleCollapseExId}) {
+  let data = row['data'];
+  const exId = `pga_ex_${data['level'].join('_')}`;
+  const parentExId = `pga_ex_${data['parent_node']}`;
+  const collapsed = collapsedExId.findIndex((v)=>parentExId.startsWith(v)) > -1;
+  const className = getRowClassname(data, collapsedExId.indexOf(exId) > -1);
+  let onRowClick = (e)=>{
+    toggleCollapseExId(e.currentTarget.getAttribute('data-ex-id'), data['Plans']?.length);
+  };
+
+  return (
+    <tr onMouseEnter={(e)=>{setActiveExId(e.currentTarget.getAttribute('data-ex-id'));}}
+      onMouseLeave={()=>{setActiveExId(null);}}
+      className={clsx(className)} data-parent={parentExId}
+      data-ex-id={`pga_ex_${data['level'].join('_')}`}
+      style={collapsed ? {display: 'none'} : {}}
+      onClick={onRowClick}>
+      <td>
+        <FiberManualRecordIcon fontSize="small" style={{visibility: activeExId==parentExId ? 'visible' : 'hidden'}} />
+      </td>
+      <td>{data['_serial']}.</td>
+      <td style={{paddingLeft: data['level'].length*30+'px'}} title={row['tooltip_text']}>
+        <NodeText displayText={row['display_text']} extraInfo={row['node_extra_info']} />
+      </td>
+      <td style={show.show_timings ? {} : {display: 'none'}}>
+        {data['exclusive'] && (data['exclusive']+' ms')}
+      </td>
+      <td style={show.show_timings ? {} : {display: 'none'}}>
+        {data['inclusive'] && (data['inclusive']+' ms')}
+      </td>
+      <td style={{display: 'none'}}>{!_.isUndefined(data['rowsx_flag'])
+        && (data['rowsx_direction'] == 'positive' ? '&uarr;' : '&darr;')
+      }</td>
+      <td style={show.show_rowsx ? {} : {display: 'none'}}>
+        {data['rowsx']}
+      </td>
+      <td style={(show.show_rowsx || show.show_rows) ? {} : {display: 'none'}}>
+        {data['Actual Rows']}
+      </td>
+      <td style={(show.show_rowsx || show.show_plan_rows) ? {} : {display: 'none'}}>
+        {data['Plan Rows']}
+      </td>
+      <td style={(show.show_rowsx || show.show_rows) ? {} : {display: 'none'}}>
+        {data['Actual Loops']}
+      </td>
+    </tr>
+  );
+}
+ExplainRow.propTypes = {
+  row: PropTypes.shape({
+    data: PropTypes.shape({
+      Plans: PropTypes.array,
+      level: PropTypes.number,
+      _serial: PropTypes.number,
+      parent_node: PropTypes.number,
+      exclusive: PropTypes.number,
+      inclusive: PropTypes.number,
+      rowsx_direction: PropTypes.string,
+      rowsx: PropTypes.number,
+      rowsx_flag: PropTypes.number,
+      'Actual Rows': PropTypes.number,
+      'Plan Rows': PropTypes.number,
+      'Actual Loops': PropTypes.number,
+    }),
+    node_extra_info: PropTypes.array,
+    display_text: PropTypes.string,
+    tooltip_text: PropTypes.string,
+  }),
+  show: PropTypes.shape({
+    show_timings: PropTypes.bool,
+    show_rowsx: PropTypes.bool,
+    show_rows: PropTypes.bool,
+    show_plan_rows: PropTypes.bool,
+  }),
+  activeExId: PropTypes.string,
+  setActiveExId: PropTypes.string,
+  collapsedExId: PropTypes.string,
+  toggleCollapseExId: PropTypes.func,
+};
+
+export default function Analysis({explainTable}) {
+  const tableClasses = commonTableStyles();
+  const [activeExId, setActiveExId] = React.useState();
+  const [collapsedExId, setCollapsedExId] = React.useState([]);
+
+  const toggleCollapseExId = (exId, hasPlans=true)=>{
+    if(hasPlans) {
+      setCollapsedExId((prev)=>{
+        if(prev.indexOf(exId) > -1) {
+          return prev.filter((v)=>v!=exId);
+        }
+        return [...prev, exId];
+      });
+    }
+  };
+  return <table className={clsx(tableClasses.table, tableClasses.noBorder, tableClasses.borderBottom)}>
+    <thead>
+      <tr>
+        <th rowSpan="2" style={{width: '30px'}}></th>
+        <th rowSpan="2"><button disabled="">#</button></th>
+        <th rowSpan="2"><button disabled="">Node</button></th>
+        <th colSpan="2" style={explainTable.show_timings ? {} : {display: 'none'}}>
+          <button disabled="">Timings</button>
+        </th>
+        <th style={(explainTable.show_rowsx || explainTable.show_rows) ? {} : {display: 'none'}} colSpan="3">
+          <button disabled="">Rows</button>
+        </th>
+        <th style={(explainTable.show_rowsx || explainTable.show_rows) ? {} : {display: 'none'}} rowSpan="2">
+          <button disabled="">Loops</button>
+        </th>
+      </tr>
+      <tr>
+        <th style={explainTable.show_timings ? {} : {display: 'none'}}>
+          <button disabled="">Exclusive</button>
+        </th>
+        <th style={explainTable.show_timings ? {} : {display: 'none'}}>
+          <button disabled="">Inclusive</button>
+        </th>
+        <th style={explainTable.show_rowsx ? {} : {display: 'none'}}><button disabled="">Rows X</button></th>
+        <th style={(explainTable.show_rowsx || explainTable.show_rows) ? {} : {display: 'none'}}><button disabled="">Actual</button></th>
+        <th style={(explainTable.show_rowsx || explainTable.plan_rows) ? {} : {display: 'none'}}><button disabled="">Plan</button></th>
+      </tr>
+    </thead>
+    <tbody>
+      {_.sortBy(explainTable.rows,(r)=>r['data']['_serial']).map((row, i)=>{
+        return <ExplainRow key={i} row={row} show={{
+          show_timings: explainTable.show_timings,
+          show_rowsx: explainTable.show_rowsx,
+          show_rows: explainTable.show_rows,
+          show_plan_rows: explainTable.show_plan_rows,
+        }} activeExId={activeExId} setActiveExId={setActiveExId} collapsedExId={collapsedExId} toggleCollapseExId={toggleCollapseExId} />;
+      })}
+    </tbody>
+  </table>;
+}
+
+Analysis.propTypes = {
+  explainTable: PropTypes.object,
+};
